\documentclass[11pt]{article}
\usepackage{amsmath,geometry,amssymb,graphicx,authblk,fancyhdr,algorithm,algpseudocode,mathtools,enumerate,listings,xcolor,url,booktabs,multirow,array,subfiles,adjustbox}

%Page style setting
%\setlength{\parskip}{\baselineskip}

\pagestyle{fancy}
\geometry{a4paper,scale=0.8}
\lhead{}
\chead{}
\rhead{\small\leftmark}
\lfoot{}
\cfoot{}
\rfoot{\thepage}

%New colors defined below
\definecolor{codegreen}{rgb}{0,0.6,0}
\definecolor{codegray}{rgb}{0.5,0.5,0.5}
\definecolor{codepurple}{rgb}{0.58,0,0.82}
\definecolor{backcolour}{rgb}{0.95,0.95,0.92}

%Code listing style named "mystyle"
\lstdefinestyle{mystyle}{
  backgroundcolor=\color{backcolour},   commentstyle=\color{codegreen},
  keywordstyle=\color{magenta},
  numberstyle=\tiny\color{codegray},
  stringstyle=\color{codepurple},
  basicstyle=\footnotesize\ttfamily,
  breakatwhitespace=false,         
  breaklines=true,                 
  captionpos=b,                    
  keepspaces=true,                 
  numbers=left,                    
  numbersep=5pt,                  
  showspaces=false,                
  showstringspaces=false,
  showtabs=false,                  
  tabsize=2
}
% Code listing style for Solidity language
\input{pseudocode/solidity-highlighting.tex}
%"mystyle" code listing set
\lstset{style=mystyle}

% Algorithm keyword 
\algnewcommand\algorithmicinput{\textbf{Input:}}
\algnewcommand\algorithmicoutput{\textbf{Output:}}
\algnewcommand\algorithmicinitialize{\textbf{Initialize:}}
\algnewcommand\algorithmicadd{\textbf{Add:}}
\algnewcommand\algorithmicmultiply{\textbf{Multiply:}}
\algnewcommand\algorithmicmethod{\textbf{Method:}}
\algnewcommand\algorithmicrandnum{\textbf{Random Values:}}
\algnewcommand\algorithmictriple{\textbf{Triples:}}
\algnewcommand\algorithmicdefine{\textbf{Define:}}
\algnewcommand\algorithmickeygen{\textbf{KeyGen:}}
\algnewcommand\algorithmicprover{\textbf{Prover:}}
\algnewcommand\algorithmicverifier{\textbf{Verifier:}}

\algnewcommand\Input{\item[\algorithmicinput]}
\algnewcommand\Output{\item[\algorithmicoutput]}
\algnewcommand\Initialize{\item[\algorithmicinitialize]}
\algnewcommand\Add{\item[\algorithmicadd]}
\algnewcommand\Multiply{\item[\algorithmicmultiply]}
\algnewcommand\Method{\item[\algorithmicmethod]}
\algnewcommand\RandomValues{\item[\algorithmicrandnum]}
\algnewcommand\Triples{\item[\algorithmictriple]}
\algnewcommand\Define{\item[\algorithmicdefine]}
\algnewcommand\KeyGen{\item[\algorithmickeygen]}
\algnewcommand\Prover{\item[\algorithmicprover]}
\algnewcommand\Verifier{\item[\algorithmicverifier]}


\begin{document}
\title{ARPA Whitepaper v0.7}
\author[*]{Derek Zhang}
\author[*]{Alex Su}
\author[*]{Felix Xu}
\author[*]{Jiang Chen}
\affil[*]{Arpachain\authorcr{about@arpachain.io}}
%\affil[*]{Arpachain\authorcr{\{derek.zhang, alex.su, felix.xu, jiang.chen\}@arpachain.io}}

\date{}
\maketitle
\thispagestyle{empty}


\thispagestyle{empty}
\begin{abstract}
\subfile{sections/abstract}

Our objective is to deploy our secure computation network as an layer2 solution to any blockchain system. Smart Contracts\cite{smartcontract} will be used as bridge to link the blockchain and computation networks. Additionally, they will be used as verifier to ensure that outsourced computation is completed correctly. In order to achieve this, we first develop a general MPC network with advanced features, such as: 1) Secure Computation, 2) Off-chain Computation, 3) Verifiable Computation, and 4)Support dApps' needs like privacy-preserving data exchange.

The remainder of this paper is organized as follows: Section \ref{sec:motivations} introduces the real world motivations which inspired us to build a secure computation network. Following motivations, we highlight our contributions in section \ref{sec:contributions}. We then cover the background of secure computation, along with a comparison of similar technologies.  Our system overview is presented in section \ref{sec:sys_overview}. There, we briefly describe our system design and implementation. In section \ref{sec:mpc}-\ref{sec:crypto}, we discuss, in detail, the major components of our multiparty computation protocol, secure computation process, and considerations in cryptoeconomics. Lastly, we review the implications and applications of the real world; this includes ecosystem design, business cases, and milestones.
\end{abstract}

\newpage
\setcounter{page}{1}
\tableofcontents


\newpage
\setcounter{page}{1}
\section{Motivations} \label{sec:motivations}
\subfile{sections/motivations}

\section{Contributions}  \label{sec:contributions}
\subfile{sections/contributions}

\section{Background} \label{sec:background}
\subsection{Multiparty Computation (MPC)}
\subfile{sections/mpcbrief}

\subsection{Other Candidates of Secure Computation}
In the past ten years, several technologies towards practical secure computation protocols have been proposed and studied. These efforts have been classified into three primary domains, i.e. homomorphic encryption (HE), multiparty computation (MPC), and trusted execution environment (TEE). 

\subsubsection{Homomorphic encryption}
Homomorphic Encryption(HE) is a form of encryption that allows computation on ciphertext, generating an encrypted result which, when decrypted, matches the result of the operations as if they had been performed on the plaintext. With such a tool, one could outsource storage and/or computation without endangering data privacy. Because HE allows calculation on encrypted data while remaining encrypted, it has been extensively researched as a candidate for secure computation. 
\begin{figure}[ht]
\centering
\includegraphics[width=10cm]{graphics/he_arch.png}
\caption{Homomorphic Encryption}
\label{fig:HE}
\end{figure}

The first concrete HE scheme was proposed in 2009, according to the work of Gentry. It introduced an interesting structure, as well as, a nice trick called bootstrapping to reduced the inherent noise that accompanied the running of additions and multiplications. This allowed practical somewhat homomorphic encryption (SHE) to develop into fully homomorphic encryption (FHE).

Nevertheless, cutting-edge homomorphic schemes cannot provide an efficient way to compute large depth arithmetic circuits due to the following constraints. First, ``bootstrapping'' adds an extra cost to an already quite heavy process. Currently, practical use of HE focuses mainly on optimization of an evaluated function, which avoids expensive processes by limiting the circuit multiplication depth. In addition, using HE schemes will lead to a huge ciphertext expansion, by the overhead from 2,000 to 500,000 or even 1,000,000 (times) according to the scheme and the targeted security level. This is due to the fact that homomorphic schemes must be probabilistic to ensure semantic security, and to the particular underlying mathematical structures. As we can see, SHE schemes are the most promising today in HE variants, and it will be utilized in our secure computation program mentioned later.

\subsubsection{Zero-Knowledge Proof (ZKP)}
Zero-Knowledge Proof (ZKP) is a method by which one party (the prover Peggy) can prove to another party (the verifier Victor) that she knows a value x, without conveying any information apart from the fact that she knows the value x. Recent blockchain project was developed to leverage ZKP as a trusted off-chain computation solution. In this protocol, the function is compiled into a circuit and transmitted to a third-party execution environment where the data will be evaluated using the circuit. Similar to FHE scheme, it cannot prove that the actual amount of work being done in remote environment. In addition to that, ZKP simply cannot guarantee the computation is secured from hacker of malicious party.

\subsubsection{zk-SNARK}

Zero-Knowledge Succinct Non-Interactive Argument of Knowledge (zk-SNARK) is a protocol which creates a framework in which a person -- called prover -- can quickly convince another person -- called verifier -- that she or he ``knows'' a secret without revealing anything about the secret. The first constructions of SNARK protocols were inspired by the Probabilistically Checkable Proof (PCP) theorem which shows that (Nondeterministic Polynomial time) NP problems statements have ``short'' PCPs\cite{micali2000computationally}. New instantiations were found which allow faster and shorter proofs, when a pre-processing state is permitted.

zk-SNARKs intend to enhance the privacy of users transacting on the Zcash blockchain. With cryptocurrencies such as Bitcoin, an individual can identify user addresses and track the movement of value between transacting parties on the blockchain. In this case, Bitcoin only provides users with pseudonymous protection, rather than complete anonymity. zk-SNARKs are designed to solve this problem by completely encrypting user transaction information on the Zcash blockchain. An abstract zk-SNARK description can be denoted as Alg. \ref{alg:zksnark}

\begin{algorithm}[htbp]
\caption{zk-SNARK}
\label{alg:zksnark}
\begin{algorithmic}[1]
\KeyGen $(vk,pk)\gets \Call{KeyGen}{\text{circuit } C,\lambda}$.
\Prover $\pi \gets \Call{Prover}{pk, \text{public input } x, \text{secret input } w}$
\Verifier $\exists w$ s.t. $C(w, x) \gets \Call{Verifier}{\pi,vk,x}$
\end{algorithmic}
\end{algorithm}

\subsubsection{Trusted Execution Environment (TEE)}
Trusted Execution Environment (TEE) is a tamper resistant processing environment that runs on a separation kernel [2]. It is another trend to solve a secure computation problem. An ideal TEE guarantees the authenticity of the executed code, the integrity of the runtime states (e.g. CPU registers, memory and sensitive I/O), and the confidentiality of its code, data and runtime states stored on a persistent memory. In addition, it shall be able to provide remote attestation that proves its trustworthiness for third-parties.

Hardware manufacturers are eager to propose their own trusted hardware solutions but lack a general standard over different platforms. Most prominent process unit designers have embedded their hardware secure module in their products (Ex. Intel Software Guard Extensions (SGX), ARM TrustZone, AMD Secure Encrypted Virtualization (SEV) and NVIDIA Trusted Little Kernel (TLK). 
\begin{figure}[ht]
\centering
\includegraphics[width=10cm]{graphics/sgx_framework.png}
\caption{Trust Execution Environment}
\label{fig:TEE}
\end{figure}

Software Guarded Execution (SGX) is a set of instructions promoted by Intel to enable code to be run at private region of CPU. The benefit of such implementation is that the application is secured at hardware level with cost of developing a software. Most solutions to provide privacy to smart contracts are based on SGX, which was a sensible choice years ago. Several projects existed are using SGX as off-chain computation solution. 

However, recent attacks have proven SGX to be inadequate. This seemingly secure protocol is, in fact, not secure at all. The remote attestation does not prevent a malicious cloud service provider from first faithfully responding to remote attestation queries, but then emulate the rest of the protocol (such as KeyGen and CSR) outside of the enclave. In other words, SGX is not a protocol designed for ``Universal Composition'' (UC) where, the real-world behavior and the ideal-world definition (function) of a protocol are computationally indistinguishable for every adversary-controlled environment. In simple term, with TEE, one can trust the hardware but not the person controlling the hardware. Therefore, the SGX stack is best used in a permissioned network\cite{permissioned}, where all nodes are pre-approved and the environment is certified and trusted.

Furthermore, SGX instructions can only be used on Intel's CPU. In cases like deep learning, where algorithms are accelerated on GPU, or in situation that Intel is not considered to be trustworthy, the SGX solution will bear significant risk. In addition, the proper use of TEE is also a nontrivial work, especially the collaboration of different TEE modules.

\subsection{Comparison} \label{sec:comparison}
\subfile{sections/comparison}


\newpage
\section{System Overview}  \label{sec:sys_overview}
\subfile{sections/summary}
We will come back to this in Section \ref{sec:crypto}.


\subsection{Interoperability}
The need for privacy-preserving computation is universal. It would be a greater benefit for other popular blockchains, such as Ethereum and EOS, to have secure computation capability. Therefore, APRA's system is designed to be inter-operable with other blockchain systems, while maintaining our own chain as a standalone network for secure computation. To be able to conduct off-chain computation, our network nodes need to monitor smart contract information on other chains, and act upon requests from these smart contracts. This realization of secure computation is called Private Smart Contract. This completely obscures the data from the public, while keeping the computation auditable. Private Smart Contracts will later be described in further detail.

\subsection{ARPA Virtual Machine (AVM)}
Similar to Ethereum Virtual Machine (EVM), The Arpa Virtual Machine is a Turing Complete Virtual Machine that can run smart contracts in it. However, to enable secure computation and other advanced features such as Private Smart Contract, AVM is shipped with a stronger toolset with close to native performance. To this end, AVM adopts WebAssembly(WASM), a binary instruction for a stack-based Virtual Machine, which lets us do more with less. WASM brings faster code, smaller deliverables, and less overhead. The Virtual Machine can execute bytecode compiled from scripting language, such as JavaScript and Python, for better adoption and less learning curve.

To enable the execution of "Private Smart Contract", a smart contract that can protect data privacy, function privacy, participants' identify and their state change, the EVM has a built-in function cryptography library for easier computation dispatch and verification.

AVM also supports native Oracle implementation. External data can be fetched and processed without the need to setup an oracle server. This will be very handy when the computation verification package is sent back from the secure computation layer.

\newpage
\section{ARPA Multiparty Computation Protocol}  \label{sec:mpc}
The protocol implemented in ARPA's computation network is organized as Figure \ref{fig:mpc_flowchart}. The procedure can be viewed as a two-phase protocol: Preprocessing and Computation. The computation phase is the main procedure that involves secret sharing, function evaluation, and revealing outcomes. On the other hand, the preprocessing phase is the foundation which provides necessary raw materials for computation. We separate these two phases apart because preprocessing is independent of both the function and the data.

\begin{figure}[ht]
\centering
\includegraphics[width=12 cm]{graphics/mpc_flowchart.png}
\caption{ARPA MPC protocol}
\label{fig:mpc_flowchart}
\end{figure} 

\subsection{Computation Phase}

During the computation phase, the main task is to securely evaluate an arbitrary circuit on private inputs which is keep secret throughout and reveal the result only when the parties follow the prescribed protocol. This phase can be concluded as a 3-stage protocol: input, evaluation, output. After private inputs are provided and secretly shared, all parties perform addition and multiplication on shared values, collaboratively, according to the arithmetic circuit. Eventually, results are opened after computing verification.

\subsubsection{Sharing secrets}
At the beginning of the computation phase, the input needs to be shared among all parties. This process is called secret sharing. Secret sharing is the method of distributing a secret among a group of participants, each of whom is allocated a share of the secret. The secret can be revealed only when a sufficient number of shares are combined together. Individual shares are unreadable ciphertext on their own.

A secret sharing scheme usually consists of two main functions, $\Call{Share}{}$ and $\Call{Reconstruct}{}$. $\Call{Share}{}$ allows one party to share a secret, $x$, among n parties such that the secret remains secure against an adversary up to $t-1$ parties in a $(t,n)$-threshold scheme. While $\Call{Reconstruct}{}$ allows any group of t or more parties together to open the secrets. In ARPA MPC, we design the secret-sharing scheme to work effectively under universally composable security so that the threshold is set to $n$, meaning our system is secure up to $n-1$ colluded malicious parties.

In the \Call{Input}{} step, parties need to use shares of random values: each party $P_i$ holds some $r_i$ and the secret value $r_i$ is uniformly random and not known by any party. First, every party sends their share $r_i$ of $r$ to party $P_{provider}$. This is called a `partial opening' because now $P_{provider}$ discovers the value of $r$ by summing the shares. Party $P_{provider}$ then broadcasts his input $x-r$. Party $P_1$ sets its share of x as $x_1 = x - r + r_1$, and for $Pi$ sets its x share of as $x_i = r_i$. In practice, it is not always $P_1$ who does a different computation. Now we turn $x$ into $\langle x \rangle$ and shares are $x_i$.


\subsubsection{Evaluating circuits} 

On ARPA's MPC framework, the function to be evaluated should be expressed in an arithmetic circuit representative. A general method to transfer high-level functions into arithmetic circuits are included in our compiler. which is concretely described in the preprocessing phase in section\ref{sec:preprocessing}. This compilation is done prior to computation phase.

The arithmetic circuit basically consists of addition and multiplication operations. In the evaluation step, since the secret sharing scheme is additive and linear, addition can be done via local computation which has no communication cost. Specifically, to compute $\langle a + b\rangle$ or $\langle \alpha \cdot a\rangle$, each party simply does $a_i + b_i$ or $\alpha \cdot a_i$. We then get the $\langle a + b\rangle $ and $\langle \alpha \cdot a\rangle$ in secret shares type.

Multiplication on secret values, however, requires some interaction between the parties. Beaver's triples are used to facilitate the online multiplication. When parties are scheduled to compute $\langle x\cdot y \rangle$ given $\langle x \rangle$ and $\langle y \rangle$ one available `triple' $\langle a \rangle$, $\langle b \rangle$, $\langle c\rangle$, where $c = a \times b$ is taken from the pre-processed raw material. Then, by broadcasting $x_i - a_i$ and $y_i - b_i$, each party can compute $x - a$ and $y - b$. Which now means these intermediates are publicly known. Eventually everyone can locally compute $z_i=(x-a)(y-b)+x_i(y-b)+y_i(x-a)+c_i$, so that they have a secret share of $\langle z \rangle$.

\begin{equation}
\begin{aligned}
\langle z \rangle &= \langle c \rangle + d \cdot \langle b \rangle +e \cdot \langle a \rangle + d \cdot e\\
&=\langle a \cdot b + (x-a) \cdot b+ (y-b) \cdot a + (x-a)\cdot (y-b)\rangle\\
&=\langle x\cdot y \rangle
\end{aligned}
\end{equation}

The upshot is that with enough amount of triples, the MPC engine can perform any multiplication depth computing on secret shared data, and hence we can compute any arithmetic circuit. For the reason that some intermediates like $x-a$ are opened for subsequent procedure, triples cannot be reused because this would reveal information about the secrets.

Importantly, it can be observed that triples are independent of not only the input data, but also the circuit to be evaluated. This means that we can generate these triples at any point prior to evaluating the circuit. The value of triples are not known by any parties when generated. Each party only knows a share of each of `some values' for which they are told this relation holds. Moreover, since addition, scalar multiplication, and field multiplication are inexpensive in terms of communication and computation, the computation phase is both highly efficient and information-theoretically secure. 

With the methodology of addition and multiplication on secret shares, we can build any computable functions on arithmetic circuits. Taking an example of secure signed floating number multiplication like Alg.\ref{alg:fpMul} \cite{aliasgari2013secure} which involves exponents addition, sign bit operation and mantissa multiplication. Specifically, multiplication of two floating point numbers $\langle v_1, p_1, z_1, s_1\rangle$ and $\langle v_2, p_2, z_2, s_2\rangle$ is performed by first multiplying their mantissa $v_1$ and $v_2$ to obtain a $2l$-bit product $v$. The product then needs to be truncated by either $l$ or $l-1$ bits depending on whether the most significant bit of $v$ is $1$ or not. In the protocol below, it is accomplished obliviously on lines 2-4. Partitioning this truncation into two steps allows us to reduce the number of interactive operations at a slight increase in the number of rounds. After computing the zero and sign bits of the product (lines 5-6), we obviously adjust the exponent for non-zero values by the amount of previously performed truncation.

Combining the above, we have now established roughly how to evaluate an arithmetic circuit.

\begin{algorithm}[htbp]
\caption{Secure Floating Number Multiplication}
\label{alg:fpMul}
\begin{algorithmic}[1]
\Require $\langle [v_1],[p_1],[z_1],[s_1]\rangle, \langle [v_2], [p_2], [z_2], [s_2]\rangle$ 
\Ensure $\langle [v], [p], [z], [s]\rangle \gets \Call{FLMul}{\langle [v_1],[p_1],[z_1],[s_1]\rangle, \langle [v_2], [p_2], [z_2], [s_2]\rangle}$
\Method
\State $[v]\gets [v_1][v_2]$;
\State $[v]\gets \Call{Trunc}{[v],2l,l-1}$;
\State $[b]\gets \Call{LT}{[v], 2l,l+1}$;
\State $[v]\gets \Call{Trunc}{2[b][v]+(1-[b][v],l+1,1}$;
\State $[z]\gets \Call{OR}{[z_1],[z_2]}$;
\State $[s]\gets \Call{XOR}{[s_1],[s_2]}$;
\State $[p]\gets ([p_1]+[p_2]+l-[b])(1-[z])$;
\State return $\langle [v], [p], [z], [s]\rangle$;
\end{algorithmic}
\end{algorithm}

\subsubsection{Information Theoretic MAC}

When using multiplication triples and a linear secret-sharing scheme with threshold $t$, we obtain a passively secure MPC protocol that tolerates up to $t$ corruptions. In the dishonest majority setting with up to $n-1$ corruptions, the most natural secret sharing scheme to use is simple additive secret sharing, where $x\in F$ is shared between n parties by distributing n random shares $x_i$ satisfying $x=\sum_1^n x_i $. Clearly, any $n−1$ shares reveal no information about the secret. However, to achieve active security, this is not enough to guarantee correct opening.

Message Authentication Code (MAC) is a value that can be used to confirm a message has been created by a certain party who knows the MAC key, and to detect if a message has been changed. The main tool for achieving active security in modern, secret sharing-based protocols is information-theoretic MAC, as mentioned in the \cite{damgaard2012multiparty} \cite{damgaard2012multiparty}. A typical information-theoretic MAC scheme is listed as Alg.\ref{alg:MAC}.


\begin{algorithm}[ht]
\caption{MAC Check Procedure}
\label{alg:MAC}
\begin{algorithmic}[1]
\Require global MAC key shares $\alpha_i$, public sets of opened values ${a_1, \dots, a_t}$, associated MAC value shares $\gamma(a_j)_i$
\Ensure succeed if $\Call{MACCheck}{}$ passed, or $\varnothing$ if inconsistant MAC value is found.
\Method
\State All parties samples a seed $s_i$ and ask $\Call{Commit}{}$ to broadcast $\tau_{s_i}$.
\State All parties open $\tau_{s_i}$ and add up to get an agreed seed $s$.
\State All parties sample random vector $\textbf{r}$ on $s$
\State Each player computes the public value $a \gets \sum_{j=1}^t r_j \cdot a_j$. 
\State Player $i$ computes $\gamma(a)_i \gets \sum_{j=1}^t r_j \cdot \gamma(a_j)_i$, and $\sigma_i \gets \gamma_i - \alpha_i \cdot a$.
\State Player $i$ asks $\Call{Commit}{}$ to broadcast $\tau_{\sigma_i}$.
\State Every player open $\tau_{\sigma_i}$.
\State If $\sigma_1+\cdots+\sigma_n= 0$, the players output $\varnothing$ and abort.
\end{algorithmic}
\end{algorithm}


The security requirement is that the verification algorithm should succeed if and only if $m$ is a valid MAC on $x$, except with negligible probability. The information-theoretic property of the MAC scheme means that security holds even for an unbounded adversary. The MAC scheme we deployed in computation network derives purely from information theory. In other words, it cannot be broken even if the adversary had unlimited computing power. The adversary simply does not have enough information to break the encryption.

MAC plays a crucial role in making MPC verifiable. MAC check scheme makes sure that malicious party in the group can not bypass the security check by blending the verification value into the computation process.

\subsubsection{Revealing outcomes}

Once we have the MAC representations, it is fairly easy to describe the online phase of an MPC protocol in the preprocessing model. Since both of the authenticated secret-sharing methods described are linear, the parties can perform linear computations by simply computing locally on the shares. We can also add a public constant c to a shared value $[x]: P_1$ adds c to her share, and each party $P_i$ adjusts their MAC by $c\cdot \alpha_i$.

To multiply two secret-shared values, the parties need a random authenticated multiplication triple from the preprocessing phase. We also need some additional preprocessing data for sharing inputs, in the form of random authenticated masks where only the party providing input knows the value. When outputting a result of the computation the parties must check the MACs using the MAC check procedure described previously, which we denote by $\prod{MACCheck}$.

In summary, the computation process can be concluded as the protocol Alg.\ref{alg:computePhase}

\begin{algorithm}[htbp]
\caption{Computation Phase Protocol}
\label{alg:computePhase}
\begin{algorithmic}[0]

\Initialize The parties first invoke the preprocessing to get the shared secret key $\alpha$ , a sufficient number of multiplication triples $(\langle a \rangle,\langle b \rangle,\langle c \rangle)$, and random values $\langle r \rangle$, as well as single random values $\langle t \rangle$, $\langle e \rangle$. Then the below steps are performed according to the compiled function structure.
\Input To share secret input x of party $P_{input}$, involved parties take a random value $\langle r \rangle$. Then do the following:
\begin{enumerate}[1.]
    \item $\langle r \rangle$ is opened to $P_{input}$.
    \item $P_input$ broadcasts $\epsilon \gets x-r$.
    \item The parties compute $\langle x \rangle \gets \langle r \rangle + \epsilon$.
\end{enumerate}
\Add To add $\langle x \rangle, \langle y \rangle$, the parties locally compute $\langle x \rangle+ \langle y \rangle$
\Multiply To multiply $\langle x \rangle, \langle y \rangle $, the parties do the following
\begin{enumerate}[1.]
    \item Sacrifice
        \begin{enumerate}[a)]
            \item $\langle t \rangle $ is opened publicly, take two triples for check
            \item Evaluate $t \cdot \langle c \rangle - \langle h \rangle - \sigma \cdot \langle f \rangle - \rho \cdot \langle g \rangle - \sigma \cdot \rho$, where $\rho \coloneqq t\cdot c-h, \sigma \coloneqq b-g$
            \item Sacrifice one triple and authenticate the other
        \end{enumerate} 
    \item Multiplication
        \begin{enumerate}
            \item Take one authenticated triple
            \item Evaluate $\langle z \rangle = \langle c \rangle + \epsilon \cdot \langle b \rangle + \delta \cdot \langle a \rangle + \epsilon \cdot \delta$, where $\epsilon \coloneqq x-a, \delta \coloneqq y-b$
        \end{enumerate}
\end{enumerate}
\Output The parties unite to reveal output $y$ in the presence of $\langle y \rangle$. Correctness of computation should be checked first. Then do the following:
\begin{enumerate}[1.]
    \item Generate random linear combination coefficient $r_i=e^i$. Then compute $a=\sum_j{r_ja_j}$, where $a_j$ are opened intermediates.
    \item $P_i$ commits to $r_i=\sum_j{r_j\gamma(a_j)_i}, \langle y \rangle, \gamma(y)_i$.
    \item Open $\alpha$.
    \item Check $\alpha \cdot a=\sum_i \gamma_i$,$ \alpha \cdot y = \sum_i{\gamma(y)_i}$. If MAC check passed, output $y\coloneqq \sum_i \langle y\rangle $.
\end{enumerate} 
\end{algorithmic}
\end{algorithm}


\subsection{Preprocessing Process}\label{sec:preprocessing}
The preprocessing model began with Beaver's ``circuit randomization'' technique, which allows any arithmetic circuit to be securely computed by randomizing the inputs to each multiplication gate, using a multiplication triple, which is a triple of secret shared values $\langle a \rangle, \langle b\rangle, \langle c \rangle$ where $a$ and $b$ are uniformly random (in a finite field) and $c = a \cdot b$. Given this, two secret shared values $\langle x \rangle$, $\langle y \rangle$ can be multiplied by publicly reconstructing $d = x - a$ and $e = y - b$ and then computing


Since $a$ and $b$ are uniformly random, revealing $d$ and $e$ does not leak any information on the inputs x,y. The key advantage of this approach is that any MPC protocol based on linear secret sharing that operates on circuits in a gate-by-gate manner can now be easily recast in the preprocessing model: the preprocessing phase simply consists of creating many multiplication triples, and in the online phase the circuit is securely evaluated using these triples. Note that additions and linear operations can be evaluated locally because the secret sharing scheme is linear. After evaluating the circuit, each party broadcasts their secret shares of the outputs and reconstructs the result. The preprocessing stage is completely independent of both the inputs to the function being computed and the function itself (apart from an upper bound on its multiplicative size), and creating triples is typically the bottleneck of a protocol. 

\begin{algorithm}[htbp]
\caption{Preprocessing Phase Protocol}
\label{alg:preprocessPhase}
\begin{algorithmic}[0]
\Initialize generates global MAC key $\alpha$ and distributed key $\beta_i$
\begin{enumerate}[1.]
    \item The players agree on the public key pk
    \item Each $P_i$ generates $\alpha_i$, $\beta_i$, and define $\alpha \coloneqq \sum_i{\alpha_i}$
    \item Each $P_i$ computes $e_{\alpha_i}=\Call{Enc}{\alpha_i}$, $e_{\beta_i}=\Call{Enc}{\beta_i}$, and zero-knowledge proves on ciphers
    \item Compute $e_\alpha=e_{\alpha_1} \boxplus \cdots \boxplus e_{\alpha_n}$, and $\Call{DistDec}{}$ it to each party.
\end{enumerate}
\RandomValues generates random values for secret sharing
\begin{enumerate}[1.]
	\item Each $P_i$ generates $r_i$, and define $r\coloneqq r_i$.
	\item Each $P_i$ computes $e_{r_i}=\Call{Enc}{r_i}$, and zero-knowledge proves on ciphers.
	\item Compute $e_r=e_{r_i} \boxplus \cdots \boxplus e_{r_n }$. and $\Call{DistDec}{}$ it to each party.
\end{enumerate}
\Triples generates multiplicative triples for online computation
\begin{enumerate}[1.]
    \item Each $P_i$ generates $a_i$, $b_i$, and define $a\coloneqq \sum_i{a_i}$, $b\coloneqq\sum_i{b_i}$.
    \item Each $P_i$ computes $e_{a_i}=\Call{Enc}{a_i}$, $e_{b_i}=\Call{Enc}{b_i}$, and zero-knowledge proves on ciphers.
    \item Compute $e_a=e_{a_i}\boxplus\cdots\boxplus e_{a_n }$, $e_b=e_{b_i}\boxplus \cdots \boxplus e_{b_n}$. and $\Call{DistDec}{}$ it to each party.
    \item Compute $e_c=e_a\boxtimes e_b$, and $\Call{DistDec}{}$ it to each party.
\end{enumerate}
\end{algorithmic}
\end{algorithm}

Considering the malicious security model, we introduced two methods to solve the following issues: First, Zero-knowledge is applied to prove that certain values lie within a certain bound in case that the adversaries introduces noise to pollute honest parties' input. Second, distributed decryption allows corrupted party to add noise in triples, where we use sacrifice to double check triples validation.

Circuit used in this paper is the terminology describing evaluation functions in cryptography, but not the hardware circuit. To represent a computation, we can use either Boolean circuits or Arithmetic circuits. The main difference is with respect to their input's types and their gates types. It is nature to use Boolean notation when processing programs on bits and by Boolean operations, such as XOR, AND. Nevertheless, arithmetic circuits work on inputs in fields F by arithmetic operations, like field additions and multiplications. Figure \ref{fig:acircuit} shows a sample of arithmetic circuit.
\begin{figure}[ht]
\centering
\includegraphics[width=12cm]{graphics/arithmetic_circuit.png}
\caption{Sample Arithmetic Circuit}
\label{fig:acircuit}
\end{figure}

\subsubsection{Compiling functions}

An MPC compiler translates a conventional function into an arithmetic or boolean circuit, in order for it to be accepted in MPC virtual machine. Corresponding to the normal compiler, which transforms high level language to assembly code, The MPC compiler turns the high-level function into MPC-friendly instructions.

The difference between arithmetic and Boolean function is not about functionality but the modality. The reason to choose one representative depends on the functions type to perform. Due to the mathematical basis, cryptography tools rely mainly on computation of field elements, which are treated as single input but not a string of bits. Then it makes sense to represent in arithmetic ways. However, many applications involve non-arithmetic operations like integer comparison, which is a basic procedure in many computations. In this case, implementing this non-arithmetic operation as an arithmetic one would be very inefficient, and Boolean circuits are a more natural representation.


\begin{table}[ht]
\centering
\begin{tabular}{*3c} \toprule
Circuits     &    Arithmetic      &     Boolean\\ \midrule
Elements     &    Bit \{$0$,$1$\} / $\mathbb{F}_2$  & Finite field $(\mathbb{F}_{p^k})^s$ \\
Underlying Operations   &    \Call{OR}{}, \Call{NOT}{}, \Call{AND}{}, \Call{XOR}{}   &   Addition, Multiplication  \\
Transform   &   Like an Arithmetic Logic Unit in processor   &  \begin{tabular}{c} 0 as addition neutral \\ 1 as multiplication neutral \\ $ \Call{OR}{a,b} = a+b-a\times b$
\end{tabular} \\ \bottomrule
\end{tabular}
\caption{Circuit Comparison}
\label{tab:circuit_comp}
\end{table}

The two representatives of circuits can be transformed to each other by an arbitrary translation shown in Table \ref{tab:circuit_comp}. The computable functions class of Boolean circuits of polynomial size correspond to the class of arithmetic circuits of polynomial size. Actually, we can picture arithmetic circuits as a generalization of Boolean circuits to arbitrary fields. There have been many papers that worked on extending cryptographic methods that work well for computations represented as Boolean circuit to the setting of computations which are best captured by arithmetic circuits, to get efficiency improvements for those circuits, or on bridging between methods adapted to both circuits, to capture computation whose best representation is a mix between the two.



\section{The Secure Computation processes} \label{sec:secure_computation}

The Secure Computation process starts from the application layer, typically by triggering a smart contract. To support off-chain computation, our network will observe smart contract events on a designated blockchain network, execute the computation work on ARPA, then submit results and proofs back to the smart contract. This process consists of 5 steps, as illustrated in Figure \ref{fig:Secure_Computation_Process}.

\begin{figure}[ht]
\centering
\includegraphics[width=10cm]{graphics/Secure_Computation_Process.png}
\caption{The Secure computation process}
\label{fig:Secure_Computation_Process}
\end{figure}

\begin{enumerate}
\item On the application layer, a smart contract representing a real-world contractual logic is initiated by a party who wants a heavy computation task or privacy-preserving task to be executed in the network while keeping the detail in private. The smart contract was created by the data provider (who charges a fee for providing information but doesn't want to expose the data to the public), or by several parties who want to engage in some private business logic.

To support off-chain computation, the smart contract could be one on another blockchain network. Our nodes can optionally observe the particular event defined in smart contract. And the result can be sent back to the smart contract by sending a message to the smart contract.

Once the smart contract received the deposit and other necessary information, such as data provider and function to be evaluated, the observing nodes will broadcast the event in the ARPA network, inviting other parties to join the MPC task.

\item All computation nodes who are interested in participating in the computation will start the bidding process. They are asked to deposit minimum required token to be eligible (detailed in Cryptoeconomics section). Next, a group of computation nodes are randomly selected, based on node's performance and condition, success rate, latency, etc. The random function used in this selection process is a decentralized random function, discussed in subsection \ref{nodes_selection}. 

One thing worth mentioning is that the data provider and data consumer are included in the group, making the computation nodes impossible to collude. This design is required so that at least one party is honest. Because our threshold protocol is secure up to n-1 parties, we can claim that this setup is \textit{cryptographically guaranteed to be secure}.

Once the quorum is determined, all bidding notes will know the result locally. This is a very important feature because even if the bribing attacker exists, he doesn't know whom to bribe or attack. The selected nodes don't need to broadcast the fact that they are selected, but instead they hold the cryptographic proof till the end of the process.

\item At the computation layer, the nodes in the pre-selected quorum coordinate together to perform ARPA MPC. As already described in previous section, they first secret-share the data. Then, a compiled function, in the form of boolean/arithmetic circuit is prepared for all parties. For each party, their job is simply to evaluate the function by following the circuit's instruction. During the computation, the parties actively exchange values on peer-to-peer communication, which is also secured with TLS. When the computation reaches the end, results and computation proofs will be produced. The computation proofs are Information Theoretic MACs produced alongside with the computation, i.e. they generated with the same computation steps as the result, making it impossible to forge. The results and MAC values will be signed with all nodes' secret keys to prevent forgery.

MACs are information-theoretic secure to convey the correctness of computation, so that the computation is verifiable. The validation complexity is $O(1)$, which means it consumes constant time to compute. Therefore it is possible to be executed in any VM. 

\item If the verification is passed, the payment will be processed, the gas fee will be distributed, and the meta-data of the transaction will be recorded on the blockchain. The ARPA consensus algorithm is discussed in section \ref{subsection:consensus}.

\item The result and MACs will also be sent back to smart contract. All nodes running smart contract will validate the authenticity of MACs, and then check the MAC's correctness. The detail of verification procedure is detailed section \ref{sec:secure_computation}. If the smart contract is running on another blockchain network, then other nodes will reach consensus by their own consensus algorithm.

\end{enumerate}


\subsection{Smart Contract}
A smart contract is executable code that runs on the blockchain to facilitate, execute and prove an agreement between untrusted parties without the involvement of a trusted third party. The benefit of a smart contract is that it can reliably transfer value, make decisions or perform computation as if there is a trusted third party. It also makes the whole executing process transparent, as anyone on the chain can audit the smart contract code and run the code to verify the results. The data processed or generated by a smart contract is also traceable in the receipt.

With many advantages, a smart contract has its limitations. The correctness of the smart contract is based on a network-wide consensus, which naturally requires every validating node to re-run it for verification purpose. This redundancy makes executing the smart contract very expensive, or in another words, the usability of the smart contract is limited. Another concern is privacy, as the smart contract itself and its data are transparent to every node on the blockchain network. 

Therefore, our approach to support off-chain computation for other chains is using smart contracts to carry the meta operations, including computation initiation, task broadcasting, and validation, so that the blockchain can reach consensus with computation proof. A pseudo-code example is provided to illustrate this concept. All of the heavy-lifting computation, including secret sharing and multiparty computation, are conducted by the MPC network.


\lstinputlisting[language=Solidity, caption=ARPA Smart Contract]{pseudocode/smart_contract.sol}

\subsection{Nodes Selection} \label{nodes_selection}
The nodes who will be participating in the computation are randomly selected based on a decentralized random function(DRF). One good candidate of such function is RANDAO, which is also a proposed in Ethereum PoS system\cite{randao}.

%Explain of DRF....

Combined with randomness from DRF, participating nodes are also selected based on the node's performance, condition, success rate, latency, etc.

\subsection{Off-Chain Computation}
Currently on-chain consensus is reached when everyone is receiving the same result, by executing smart contracts on each individual VM. There is no final authority when decentralized. Everyone has to validate every transaction in order to agree with others. The most prominent problem is the amount of gas consumed for every block. The reason that everyone has to repeat the same calculation is that blockchain is a trustless network and everyone must do the same and reach to the same result to trust others. In other words, there is no way to verify the result without actually going over the whole process, i.e. executing the code, in a trustless network.

Computation-intensive calculations are expensive on Ethereum and solidity is not good at expressing complex functionality. One way to compute complex function is to simply run it off-chain. Various solutions\cite{plasma, truebit} are focused on how to prove the correctness of an off-chain computation.

In order to bring computation off-chain, we need a verifiable scheme in the computation delegation process. For example, if one wants to prove that they have been somewhere, the best proof is an item that is unique to that place, such as a souvenir. We can think of off-chain computation as a delegation process, and the envoy has to prove that he actually did finish the task. Similar to this concept, an off-chain computation scheme needs a verification scheme that:
\begin{enumerate}
    \item Can prove that the computation is faithfully done,
    \item The amount of work done cannot be exaggerated, and more importantly,
    \item The privacy of the content is guaranteed and nothing is revealed to the participants.
\end{enumerate}


This relationship is illustrated in Figure \ref{fig:off-chain-computation}
\begin{figure}[ht]
\centering
\includegraphics[width=8cm]{graphics/Off-chain_computation.png}
\caption{Off-chain computation}
\label{fig:off-chain-computation}
\end{figure}

We use Information Theoretic MAC to attain these desired properties. The following section will describe how MAC is used and why it can become the critical component in off-chain computation.


\subsection{Computation Verification}
Computation Verification scheme is the cornerstone of verifiable computation. As mentioned earlier, the current state of smart contract execution is duplicated across all nodes on blockchain. However, using MPC, the computation is guaranteed by mathematics and can be safely delegated to another set of nodes. In other words, the process can be trusted by a third party, as long as they provide proof that the process is done in a correct way. This question can be further broken down into three conceptual parts:
\begin{enumerate}
    \item The computation is conducted with prescribed function and correct input data,
    \item The proof cannot be forged, and
    \item The proof can be verified by other nodes.
\end{enumerate}
Under our MPC protocol, we are securing up to n-1 malicious notes using MAC. As described earlier, MAC is a value that can be used to confirm a message has been created by a certain party who knows the MAC key, and to detect if a message has been changed.

While the Smart Contract is being executed, a secure computation request is sent out from an external blockchain node to the computation layer. The computation network then selects several nodes for the task, and data provider's node is also included in the group. If any other party deviates from the protocol, such as sending incorrect result, the proof-carrying data will not be reconciled and the result will be discarded. Therefore, part 1 is guaranteed by our MPC protocol cryptographically.

After each party in the computation group finishes their work, they sign their MAC with their own private key, and store them on the DHT-based distributed storage. This prevents the MAC from being forged by a third party. Therefore, the proof cannot be forged and can be trusted to be authentic, even on a publicly-accessible storage. This produces desired property of part 2.

On the consensus layer, it is easier to claim that nodes should not trust other computation proof if they did not participate in the actual computation. Since the computation nodes was selected randomly, it takes all $n$ nodes to be colluded to pass the MAC check, which is a negligible probability or extremely high cost for the malicious party to control almost all the nodes in the network. And in such case, the network is probably does not exist anymore. In other words, the probability that can one trust the consensus network but not the computation network is not plausible.

Therefore, under the protocol, we know that if MAC does not pass the check, it means the computation was wrong because some node did it incorrectly. On the opposite, if the MAC does pass the check, we know that the computation was done correctly and the result can be trusted.

In summary, we now can conclude that the secure computation can be broken down into computation and verification parts. Further, we are able to prove that by using a privately-signed MAC, we can trust the related result, as well the identity of the signer.



\subsection{MAC with Off-chain computation}
In our off-chain computation phase, MAC is used in secret sharing schemes to ensure that corrupted parties cannot lie about their share and cause an incorrect value to be opened during reconstruction. The following equation shows how MAC proves correctness and integrity of computation. The protocol is under a full threshold active security model where security is guranteed even there is one honest party. This particular party can be data provider or computation initiator who has natural motivation to follow rules.

An authenticated secret value $x \in \mathbb{F}$ is defined as the following:
\begin{equation}
\langle x \rangle = (x_1, \dots, x_n, m_1, \dots, m_n, \alpha_1, \dots, \alpha_n)   
\end{equation}

where each party $P_i$ holds an additive sharing tuple $(x_i, m_i, \alpha_i)$ such that:
\begin{equation}
x=\sum_{i=1}^n{x_i},  x\cdot \alpha=\sum_{i=1}^n{m_i}, \alpha =\sum_{i=1}^n{\alpha_i}.
\end{equation}

When open a value $\langle x \rangle$, all players do the following protocol:
\begin{enumerate}
    \item Compute $\sigma_i=m_i-\alpha x_i$.
    \item Call \Call{FCommit}{} with (Commit, $\sigma_i$) to receive handle $\tau_i$
    \item Broadcast $\sigma_i$ to all parties by calling \Call{FCommit}{} with (Open, $\sigma_i$).
    \item If $\sum_i{\sigma_i}\neq 0$ then abort and output $\perp$; otherwise continue.
\end{enumerate}

The protocol achieves the integrity and correctness of computation by information-theoretic security of secret sharing and the following property.

\begin{equation}
\begin{aligned}
\sum_i{\sigma_i} &= \sum_i{(m_i - \alpha x_i)} =\sum_i{m_i} -\alpha\sum_i{x_i} \\
\sum_i{\sigma_i} &= \sum_i{(m_i - \alpha_i x)} = \sum_i{m_i} -x\sum_i{\alpha_i}
\end{aligned}
\end{equation}

It can be observed that, when given a MAC global key or value $x$, the protocol can check the result with MACs. These two ways can be used to ensure the correctness of computation by checking on intermediate and result by checking on output. Now we can see how MAC helps to protect the computation when at least 1 party act honestly.

Furthermore, we can also find that the broadcast value $i$ leaks no information on either secret value or MAC value because they are not correlated. Therefore, it is possible to transfer this check from computation layer to consensus layer, which helps to reach consensus on-chain. Also, the final summation of $i$ is mathematically simple to deploy any kind of virtual machine. In conclusion, MAC check is the ideal operation to promote consensus and protect computation privacy.


\textbf{Public auditable MPC} \cite{baum2014publicly} lift verifiability to arbitrary secure computations. Auditability means that even if \textit{all} the servers are corrupted, anyone with access to the transcript of the protocol can check that the output is indeed correct. This characteristic enables the separation of the input parties, computing parties, and the validator. After the protocol is executed, anyone acting as the validator can retrieve the transcript of the protocol from the bulletin board, and determine if the result is valid or not by using only the circuit and the output. The protocol will instruct computing parties to make part of their conversation public and logged on the bulletin. The verification is reached by linear commitments on secret inputs instead of traditional use of non-interactive zero knowledge proof.

The more ambitious properties that public auditable MPC is willing to achieve are universal verifiability, where the validators must not know the output and observe any process of the computation, but still hold computing parties accountable by Pedersen commitment.

\subsection{Data Storage}
The Distributed Hash Table (DHT) is a decentralized distributed storage system that provides a look-up service similar to a hash table. The data is distributed over the whole network of nodes, while any data is searchable by querying any node. To achieve that, the DHT (Figure \ref{fig:DHT}) defines a key space (for example, 160-bit string) and maps the entire data set onto this key space. The key space is then partitioned into chunks and assigned to nodes so that a node is only responsible for storing part of the data set. Another property is that every node keeps an index of mapping from key to the address of node(s) which stores the data with that key. With an overlay network connecting all nodes, a query that reaches any node can leverage the index to be routed to the node hosting queried data.
\begin{figure}[ht]
\centering
\includegraphics[width=6cm]{graphics/DHT.png}
\caption{DHT lookup}
\label{fig:DHT}
\end{figure}

The decentralization and fault tolerance nature enable DHT to be more resilient to a hostile attacker than a typical centralized storage system. DHT can also be designed to have Byzantine fault tolerance\cite{lamport1982byzantine}. This makes it feasible to handle MAC value storage in ARPA's network, as no individual MPC node can be trusted. On the other hand, if we choose an arbitrary MPC node to store the MAC value, there is a chance that the node will supply a forged value, either because it happens to be a malicious node or it is under hostile attack.

\section{Cryptoeconomics} \label{sec:crypto}
Bitcoin is considered the first massive deployment of a Byzantine Fault Tolerant (BFT) protocol in real world. Byzantine failures are considered the most general and most difficult class of failures among the failure modes. In 1999, the Practical Byzantine Fault Tolerant(PBFT)\cite{pbft} was introduced and received immediate notice. The algorithm is designed to work in asynchronous systems and is optimized to be high-performance, with an impressive overhead runtime, and only a slight increase in latency. However, the solution works on a permissioned system, meaning that the nodes have to be authorized to join the network. This property works well on closed blockchain system like Hyperledger\cite{hyperledger}, Steller\cite{mazieres2015stellar} and Ripple\cite{schwartz2014ripple}.

The Bitcoin network, on the other hand, is a permissionless network. It works in parallel to generate a blockchain allowing the system to overcome Byzantine failures and reach a coherent global view of the system's state. To achieve decentralized consensus on a permissionless network, Bitcoin invented a new consensus scheme called proof-of-work. This consensus scheme has three major properties:
\begin{enumerate}
   \item The "work" is a NP hard problem to prover but easy to verify by verifier.
   \item The more stake (computation device) and cost (electricity) a node is willing to put into the system, the higher the chance that this node will be the first to solve the work.
   \item The node who solves the work first will be rewarded and its ledger is broadcasted and trusted.
\end{enumerate}

The prover, who found the hash value that satisfies the nonce, can be trusted because he puts tremendous efforts/cost/stake in this game, and it would not be a rational decision to hack the system. Otherwise he gained nothing with depreciating token value.

The difference between PBFT and Bitcoin is that the former makes an honest assumption of participants (a permissioned network), while the later gives a more realistic and real-world assumption of \textit{Economic Rationality}\cite{rationality}, a concept from neoclassical economics, which is maximization of subjective utility. Chain-based blockchain systems like Bitcoin or Ethereum prefer plausible liveness to correctness, while BFT consensus algorithm can ensure transactional correctness but may not be able to finalize conflicting blocks and can get stuck. 

In Ethereum and other blockchain networks based on the Nakamoto(Proof-of-Work, or PoW) consensus, the fundamental assumption is that the computation resource is scarce. If everyone is verifying transactions, there will be no final state of transaction history agreed by everyone. If a leader in the network propose a block of transaction and everyone else only has to verify that, the situation is alleviated. Therefore, consensus is reached based on block of transactions, proposed by a participating node who solved a cryptographic puzzle using fairly large amount of computation power. This brings a trustworthy "finality" to the blockchain network. In essence, Bitcoin created a game where verification (of the hash work) is much more simpler than the computation of the function(verify the transactions). Nakamoto consensus protocol transfers the trust needed to verify transactions to a puzzle game. With \textit{economic rationality} mentioned ahead, the finality of the state is set by a trusted leader who solves the hash puzzle. 

Similar to how Bitcoin reached decentralized consensus, our work makes \textit{Economic Rationality} assumption to MPC, so that the cryptographic protocol can be deployed as a permissionless network. On the contrary to the assumption of Proof-of-Work consensus, ARPA designed the MPC protocol where verification of computation is even simpler than hash verification, using information theoretic MAC. This feature opens new possibilities of consensus, explained in the \textit{Consensus}(\ref{subsection:consensus}) section.


\subsection{Economic Rationality}
We aim to deploy an MPC network with cryptoeconomics considered. While in cryptography the most basic assumption is that some parties are simply honest (or not), in economics the assumption is that the parties are rational and their utilities can be quantified, such that with a proper incentive mechanism all (or at least most) of them can be discouraged from deviating the protocol.

Under rational behavior, everyone will attempt to break from the rule and gain as much as possible. But to a point where no more economic benefits one can gain. If the situation occurs where deviating the protocol, or even sabotaging the whole network, is in the best interest for the participating nodes, they would do so for their own benefit. On the contrary, participants will follow the protocol if the incentive received when following protocol is more than expected return from breaking it. 

We designed a incentive system that will punish those who deviates from the protocol, and the punishment is more than the expected return when colluding with others. This will eliminate participating nodes to take chance in the system. This system will be explained in detail in section \ref{accountable}.

Sybil attack is common in peer-to-peer network, in which spawning identities will help the attacker to gain disproportional advantage on voting or influence. In PoW consensus scheme, the spawned nodes are bounded by the real computation power on their physical machine. Therefore, the risk of sybil attack is mitigated. 

We designed a credit system that each node is in multiround game system, and it is the best interest for them to keep the same identity (than register a new address) and follow the protocol. 

Without rationality, one can simply believe that the super admin of AWS (or anyone with unlimited computation resources) can attack Bitcoin and destroy its belief system. But in reality, it doesn't have to be worried because
\begin{enumerate}
    \item A rational person would not do so without a budget. 
    \item When invested with computation resources, a rational participant would rather make more economic return by staking in the game than sabotage a network with some upfront cost.
    \item A rational person will not assume that others would so that
\end{enumerate}
Therefore, it can be concluded that this sabotage behavior will never happen.

With a properly designed incentive system, one brings the question from a mathematical (absolute) perspective to a more realistic angle, where every participant can be "guided" to follow the protocol, and those who don't will be punished.


\subsection{Identity and Reputation}
At the time a new node joins the computation network, it is allocated a unique account in the consensus layer. The account will be served as public identity of such node. With asymmetric encryption, the network can generate private/public key pairs as the identity for a node. The public key serves as the node identification and information authentication. To prove the authenticity of the result, one has to sign the MAC value with its private key. 


\subsection{Accountable safety}\label{accountable}
The computation node participating in the computation has to put up a stake in order to participate in a computation task. 

We require the staking value to be: $$x = max(computation\:stake, intel\:value\:stake) \cdot security \:multiplier $$
where:
 $$computation\:stake=(total\:computation\:resources\:estimated) * (n-1) $$
and $Security\: multiplier$ can be a constant determined by the network

There are several ways to break the protocol and be a malicious node. Each case is listed and we will analyze how our system can handle such behavior.

\paragraph{Not following the circuit}: functions are compiled in an arithmetic circuit for the nodes to compute jointly. If a node does not follow the instruction, the result will be incorrect. However, since we require MAC as a proof of computation, and the proof is tightly linked to the computation process, we can immediately tell if the result deviates from the assigned function by verifying the MAC all together. Using MPC validation, there is actually no point of doing so. Another argument of not doing so is that, since the computation is heavy, it makes more sense to just abort the task if one wants to sabotage the computation, in which case we will refer to case 4).

\paragraph{Sending out incorrect result:} as detailed in MAC session, it is impossible to send the wrong value with the correct MAC, as the MAC is paired with the result and can be detected.

\paragraph{Sending out incorrect MAC:} the MAC cannot pass the validation process and there is no benefit of doing so.

\paragraph{Abort attack:} similar to DoS (Denial of Service) attack, the node simply stops in the middle of the collaborative computation. Under such case, we can set up a timeout parameter for the computation task. If one party in the computation task fails to return before the timeout, then the task can be deemed as failure. The party then should compensate others the cost of computation resources already spent in the task. A stake larger than $(total\: computation\: resources\: estimated) \cdot (n-1)$ should be required at the election phase to prevent abort attack.

\paragraph{Stealing the data:} MPC is designed to deal with this problem – how to compute a function with distrusted parties without leaking the data. Our MPC protocol is designed to be secure up to $n-1$ colluded parties. In our case, in addition to the original $n$ party who agreed to compute, we will also select $m$ additional random nodes to increase the security. One has to collude all $n + m$ parties to steal information. This is impossible because the original data owner cannot be colluded. 

In sum, our staking mechanism is designed in such a way that, it is in the best interest of each participant to follow the protocol. This is due to the greatest benefit of the malicious action being lesser than the greatest expected loss of following the protocol. 

\subsection{Uncoordinated majority}
We assume that all nodes are rational in a game-theoretic sense, but no more than some fraction (often between 25\% and 50\%) are capable of coordinating their actions. The Proof-of-Work in Bitcoin with Eyal and Sirerʼs selfish mining fix is robust up to 50\% under the honest majority assumption, and up to 23.21\% under the uncoordinated majority assumption\cite{eyal2018majority}.

Under ARPA's MPC framework, with $t-1$ unconditional security, coordinated majority is unrealistic, because the . Because the colluded party needs to collude almost all nodes to be able to control the network. See Table \ref{tab:coordinated_chance}, where a coordinated attack requires all parties in a MPC computation to be colluded. With even 95\% of the nodes are colluding together, they still have less than 1\% chance to be able to break the security protocol.

\begin{table}[ht]
    \centering
    \begin{tabular}{*3c}   \toprule
      Coordinated\%   &  Quorun   &    Chance \\   \midrule
       50\%            &  100      &     0.00\%  \\
       60\%            &  100      &     0.00\%  \\
       70\%            &  100      &     0.00\%  \\
       80\%            &  100      &     0.00\%  \\
       90\%            &  100      &     0.00\%  \\
       95\%            &  100      &     0.59\%  \\
       98\%            &  100      &     13.26\%  \\
       99\%            &  100      &     36.60\%  \\  \bottomrule
       
    \end{tabular}
    \caption{Coordinated chance}
    \label{tab:coordinated_chance}
\end{table}


Clearly, it is unrealistic to make economical benefit when 95\% nodes are from the same party. Because it is virtually hosting a private network and hope to steal token issued on its own.

In addition, in most cases, the data provider will be a part of the MPC group. And because the data provider will not collude with others, there is zero chance that the colluding parties will break the protocol and get the secrets.

Similar to PoW, joining a MPC network requires a decent computer in order to be able to earn reward on MPC tasks. This investment prevents attacker to flood the network with virtual nodes.

\subsection{Bribing attacker model}
Attacker is motivated to make the network fail in some way. Attacker can be one of the participants, or the attacker can sits outside the protocol, and has the ability to bribe any participants to change their behavior. Attackers are modeled as having a $budget$, which is the maximum that they are willing to pay, and we can talk about their $cost$, the amount that they end up paying to disrupt the protocol equilibrium.

As discussed at section \ref{nodes_selection}, the participating nodes are selected at random, and the selected party will not be publicly known until they have completed the computation. Therefore, there is no target for the  attacker to bribe with.

Without a bribing target, an attacker needs to bribe more than 95\% nodes to make a substantial impact on the network. Even the attacker can wait passively until the chance to appear, the cost to bribe the whole network is much more than a reasonable attacking budget and thus rendered unrealistic. 

With a proper penalty designed, a hidden bribing target, and a high threshold to bribe the whole network, ARPA's network can still be secure under this security model.


\subsection{Consensus Algorithm} \label{subsection:consensus}
The blockchain consensus algorithm mainly solves two problems - who is responsible for mining the block and what to do when there is a fork. Difficulties usually lie on how to solve the fork, that is, when there are two or more legitimate forks, how to let everyone agree on one chain and continue, which requires a unified standard of judgment. Nakamoto consensus chooses the most expensive fork with the highest cost, and verification of the most expensive chain has to be objective and verifiable, which is, the Proof-of-Work. It does not mean that there is only one way to solve the fork. Such as God's dice, where everyone agrees on the fairness of the dice. Whenever there is a fork, the dice can decide on a fork. This consensus can also ensure the normal operation of the blockchain system.

How to design a practical and verifiable fair random number generator based on the blockchain has become an important research problem in recent years. There were programs \textit{Randao} proposed by Vitalik Buterin\cite{randao2016tor}, some DApps that used Oraclize to obtain the random numbers from the off-chain service, to implement a blockchain random number generator. The Ethereum Foundation also listed random number generation on the blockchain as an important issue to be researched for the next 2 to 3 years\cite{ethereum2018randnum} and invited all parties to participate on a solution.

In ARPA's network, consensus is designed with a two step development plan. Phase 1 is a PoW consensus scheme, where a new block is found and broadcast by a mining node who find a hash result satisfying the nonce of the network. A phase 2 consensus is reached by a lottery system, where participants purchase tickets a few blocks ahead to enter the candidate pool. At block creation time, the candidates together calculate a pseudo-random function, using block header and other transitional information as the seed for the random function.

\subsubsection{Nakamoto Consensus}
ARPA is dedicated to make a general-purpose secure computation network available for the first time in history. While Proof-of-Work consensus is known for its waste of energy, its stableness and secureness are still being recognized and used in most major blockchain networks. 

At the beginning of our development phase, ARPA's team will focus on solving the cryptographic challenges in MPC protocols and computation layers of the network. Rather than being innovative at every corner of our first release, a decent and proven version consensus algorithm will be used at our first release of mainnet. Therefore, a Proof-of-Work consensus algorithm will be chosen so that we can spend more efforts to the development of secure computation layer and make it really robust. 

We will use multiple hashing functions at random to prevent ASIC chips mining in our network, because we prefer participating nodes joining ARPA to have  decent computing power using CPUs (the capability desired by MPC). Choosing hashing function randomly at each block guarantees that the mining nodes would be able to conduct general-purpose computation with the capability of CPUs, one that cannot be reached by ASIC chips.

\subsubsection{Lottery Consensus}
%\subsection{MPC Consensus}

The pseudo-random function must have the following characteristics: deterministic, provability, uncontrollability, unpredictability and Tamper-resistant to attacks.
\begin{itemize}
    \item Deterministic: given all information revealed, the result will be determined and unique.
    \item Provability: The result can be validated by anyone after the information was revealed.
    \item Uncontrollability: The result cannot be influenced by anyone, or a partially colluded group.
    \item Unpredictability: Using transitional information such as block header, time, participants address, will result unpredictable random result.
    \item Tamper-resistant: The result cannot neither be calculated ahead of time, nor be forged with huge amount of computation power.
    \item Privacy: The random result is opened but only the winner knows he won the lottery. Therefore the attacker doesn't know the target until the winner broadcasts the signed validation.
\end{itemize}

Several choices for random generator are: RANDAO, BLS-based multisig, or Secret-sharing based pseudorandom. All can achieve the desired characteristics mentioned above. Our protocol is designed as follows: At block time $t$, the nodes who want to become the validator, purchase a ticket to be eligible and submit a hash proof. At time $t+x$, where $x$ is the waiting period, each party generates $p_i$ corresponded to the hash committed before. We formally describe the procedure in Alg.\ref{alg:DRF}

{\centering
\begin{minipage}{.7\linewidth}
\begin{algorithm}[H]
\caption{Decentralized Random Function}
\label{alg:DRF}
\begin{algorithmic}[1]
\Method
\State Decide $n$ participants in the game
\State $p_i \gets \Call{sha3}{s_i}$: Output a hash value by random value $s_i$, related to transnational information.
\State $P \gets \sum p_i$: Open value $P$ and reveal secret $s_i$
\State $0/1 \gets \Call{Ver}{s_1, s_2 \dots s_i}$: Check if the $Commit$ on $s_i$ is correct. The result of $P$ is valid if honest check is passed for everyone.
\end{algorithmic}
\end{algorithm}
\end{minipage}
\par
}



 If the authentication check passed, we calculate $r = R\: MOD \:n$, and obtain the randomly selected group of nodes. One of the nodes will become the $prover$, and the rest will become the $validator$. The $prover$ will create a block containing all recent valid transactions, and the $validator$ will challenge the $prover$ by checking the validity of the new block. If $prover$ failed to create a valid block, it will lose its deposit. Otherwise, the $prover$ will be rewarded with a small fee, along with the ticket price.


\subsection{Token Usage}
ARPA tokens, the native token for ARPA, perform five interconnected and critical functions within the ecosystem, over dispersed, dynamic networks:

Medium of Exchange – all transactions within ARPA computation network use ARPA tokens as the medium of exchange for services. For example, data providers receive token payment from data consumers, while model providers receive token payment from data owners

Computing Cost – ARPA tokens are exchanged to perform secure multiparty computation and compensate for computation providers. Computation cost is measured in triples used during the process and other factors

Stake – computational power providers will use the ARPA token as a form of safety deposit for launching and fulfilling computation jobs. Abort during computation and other malicious actions result in loss of stake. This will ensure fairness for all parties and limit misuse of ARPA by bad actors

Transaction Fee – similar to gas fee on Ethereum, ARPA tokens are paid to nodes facilitating the transaction as a fee

Backing of Data or Model – all audiences of ARPA's network, ranging from normal crypto audiences and network stakeholders to professional investment entities, can back public data or model following Additive Backing System. Additive Backing System broadens ARPA's audiences and incentivizes early adopters and backers of ARPA's data marketplace.

\section{Experiments}  \label{sec:experiments}
Various experiments are conducted in privacy-sensitive applications, like auction or machine learning. The performance of the practical results shows that under suitable optimization and diligent function compilation, the overhead caused by computation and communication can be largely mitigated. With such effort, the security and privacy brought by MPC is worth the price of only 2-3 magnitudes of additional computation power.

\subsection{Vickrey Auction}
As for the high party number case, a secure Vickrey second price auction is implemented on AWS instances, where 100 parties input one bid each. The auction system will reveal the winning bidder and the second-high bid. The Vickrey auction requires 44,571 triples. The performance is listed in Table \ref{tab:vickrey}.

\begin{table}[ht]
\centering
\begin{tabular}{ *3c } \toprule
 Party number & Offline phase & Online phase \\ \midrule	
 100 & 98 s & 1.4 s \\  \bottomrule
\end{tabular}
\caption{Vickrey Auction Performance}
\label{tab:vickrey}
\end{table}

To make it more general. An evaluation experiment on different circuit depth and party numbers is performed. The underlying field is set as 61-bit Mersenne field, security is approximately 260. The test is done for different numbers of parties on a series of circuits of different depths, each with 1,000,000 multiplication gates, 1,000 inputs wires, 50 output wires. The circuits had 4 different depths: 20, 100, 1,000 and 10,000. The experiment was run on AWS in a local network configuration in North Virginia region AWS. Each party was run in an independent AWS C4.large instance (2-core Intel Xeon E5-2666 v3 with 2.9 GHz clock speed and 3.75 GB RAM). Each execution (configuration, number of parties, circuit) was run 5 times, and the result reported is the average run-time. The computation overhead is depicted in Figure \ref{fig:computation_overhead}
\begin{figure}[ht]
\centering
\includegraphics[width=10cm]{graphics/computation_overhead.png}
\caption{Computation overhead in Vickrey Auction}
\label{fig:computation_overhead}
\end{figure}



\subsection{Deep Learning}
We will describe the implementation of Convolutional Neural Networks (CNNs) using MPC. The biggest problem here, when training large neural networks, might be the maturity and availability of arbitrary precision arithmetic on GPUs. Although some hope exists, this area is still under developed and needs further exploration. In this experiment we will still use CPU as an execution environment.
Our MPC approach uses secret-sharing to mask the values used in the computations. This allows for arithmetic circuit evaluation, which is greatly more efficient for training neural nets. Both the ReLU and max pooling are nonlinear operations, which are expensive to compute in MPC. Therefore, the ReLU is approximated using a polynomial and the max pooling is replaced by average pooling. 
A simple implementation of a convolutional layer can be found here, which is used as a basis for our implementation.

\begin{lstlisting}[language=python, caption=Convolutional Neural Networks (CNNs) with MPC]
def conv2d(x, filters, strides, padding):
    # shapes, assuming NCHW
    h_filter, w_filter, d_filters, n_filters = filters.shape
    n_x, d_x, h_x, w_x = x.shape
    h_out = int((h_x - h_filter + 2 * padding) / strides + 1)
    w_out = int((w_x - w_filter + 2 * padding) / strides + 1)

    X_col = x.im2col(h_filter, w_filter, padding, strides)
    W_col = filters.transpose(3, 2, 0, 1).reshape(n_filters, -1)
    out =
      W_col.dot(X_col).reshape(n_filters, h_out, w_out, n_x).transpose(3, 0, 1, 2)
    return out
\end{lstlisting}



For the dot products, specialized triples are created, ensuring that every value used in a dot product is only masked once. And for the convolution for which holds: im2col(A)⋅B=C. Therefore, only a masked version of both the inputs (masked with A) and the weights (masked with B) are communicated, without any duplicates. 

\paragraph{Reusing triples} When a variable A is used in two operations with B and C to create D and E, we can create triples such that: $operation_1(A,B)=D$  and  $operation_2(A,C)=E$. In the backward phase the error is typically used in two operations: once to compute the backpropagation error, for the previous layer, and once to compute the weight updates. Moreover, both the weights and the layer inputs have been used already in operations in the forward phase to compute the layer output, and can therefore be reused in the backward phase.
To gain insight, we compare the number of values communicated per participant in one iteration for a batch size of 128 images from MNIST of a simple two layer convnet with the optimized version. For the baseline, the backward phase is more expensive than the forward phase. For the optimized model, it is the other way around. This is mainly because we can reuse the masks created in the forward phase.


\begin{table}[ht]
\centering
\begin{adjustbox}{max width=\textwidth}
\begin{tabular}{ *9c } \toprule
 Layer & Forward & Backward & \multicolumn{2}{c}{Total} &Forward & Backward & \multicolumn{2}{c}{Total} \\ \midrule	
 conv2D(32,3,3) & 903K & 4,114K & 5,018K & (17\%) & 101K & 803K & 903K & (18\%) \\
 avg\_pooling2D(2,2) & - & - & - & - & - & - & - & - \\
 ReLU(approx) & 3,211K & 3,211K & 6,423K & (22\%) & 1,606K & 803K & 2,408K & (47\%) \\
 conv2D(32,3,3) & 7,235K & 8,840K & 16,075K & (54\%) & 812K & 201K & 1,013K & (20\%) \\
 avg\_pooling2D(2,2) & - & - & - & - & - & - & - & - \\
 ReLU(approx) & 803K & 803K & 1,606K & (5\%) & 401K & 201K & 602K & (12\%) \\
 dense(10,1568) & 216K & 219K & 435K & (1\%) & 216K & 1K & 218K & (4\%) \\ \midrule
 total & 12,368K & 17,188K & 29,556K & (100\%) & 3,136K & 2,008K & 5,144K & (100\%) \\
 
 \bottomrule
\end{tabular}
\end{adjustbox}
\caption{Communicated number of 128-bit values per iteration in the double conv layer architecture}
\label{fig:convnet}
\end{table}



\section{Ecosystem \& Applications} \label{sec:ecosystem}
In this section we discuss how business logic and applications can be built when secure computation is available. This can happen either on other blockchain system with the ARPA system enabled, or directly on ARPA's own blockchain.

\subsection{Design}
\subfile{sections/ecosystem-design}

\subsection{Participants}
\subsubsection{Computation Nodes}
Computation nodes supply computing power and storage for multiparty computation. Computation nodes have to put up a safety deposit of ARPA's token(s) for computation tasks based on projected triple consumption. In case of abort, the node's safety deposit is compensated to other nodes in the same MPC task, as well as, to the next group of nodes performing the same task. 

Computation nodes have the following attributes:
\begin{itemize}
    \item Strong computing power to ensure fast triples generation during the data pre-processing phase of multiparty computation
    \item High availability and uptime during online computation, guaranteed by node's stakes
    \item Fast and reliable internet connection, governed by the node's stakes
\end{itemize}

\subsubsection{Data Providers}
Data providers can be either individuals, enterprises, research institutions, financial,  and medical institutions that possess valuable but under-utilized data. ARPA enables data providers to securely monetize their data with privacy-preserved computation. Data providers earn token by sharing out data value but not data ownership. ARPA's privacy-preserving feature for the data marketplace can potentially unlock massive amounts of data from enterprises, as well as, from individuals as a new way of data monetization. 
\subsubsection{Data Consumer}
Data consumers can be enterprises, researchers, government, universities, and individual developers that rent data to run models, monetizing on analysis output and training AI/ML models. Data consumers pay token(s) for access to data, and benefit from lower costs by renting data. Not by buying data from suitable enterprises or individuals. Data consumers can also leave ratings and reviews for a data-set after the transaction takes place. Essentially ARPA's privacy-preserving computation cuts out data aggregators and intermediaries that used to take majority of profit within data transactions. 
\subsubsection{Model providers}
Model providers can be enterprises and individual developers that own models and would like to monetize models based on usage. Model providers earn tokens renting out models and also get incentivized sharing models to ARPA's network. Models can be rented on a pay-per-use basis or by subscription. Without potential data leakage risks, data owners can screen for the best model available on ARPA, run the model with data in a cryptographically secure way, and get insightful output from the model provider. One use case can be running analysis for medical data from hospitals where a third-party AI developer directly processes encrypted medical data and sends back results to hospitals without access to raw data. 
\subsubsection{Data / Model Backers}
Data and model backers can be individuals and enterprises that invest in public datasets or models, and receive revenue shares in tokens. Data and model backers can range from normal crypto audiences and network stakeholders, to professional investment entities. Any dataset or model made available to the public at ARPA will mock up 20\% of the dataset selling price. This price difference will be distributed to data backers. It is generally hard to price datasets even when they are visible rather than encrypted, and therefore we introduce an Additive Backing System (ABS) to reflect data quality. ABS is designed to broaden ARPA audiences and attracts more early adopters of the network. 

The basic rules of ABS are:

\begin{algorithm}
\caption{Additive Backing System}
\begin{algorithmic}[1]
\Input $R_{share}$, $N_{backer}$;
\Output $R_{share}$, $P_{invest}$;
\Define Variable definition as follows;
    \begin{enumerate}
        \item $P_{invest}\coloneqq$ Investment amount of newcomer;
        \item $R_{share} \coloneqq$ Revenue share of each backer;
        \item $R_{backer} \coloneqq$ The revenue of all backers;
        \item $N_{backer} \coloneqq$ Index of backers;
    \end{enumerate}
\Method
\State $ R_{share}=R_{backer} / N_{backer} $ , $P_{invest}=N_{backer}$;
\State The $n$th person backing the dataset pays $n$ ARPA token;
\State The revenue share of dataset is evenly distributed to $n$ backers;
\State The $i$th person who can sell his position at $n+1$ ARPA token, given there are $n$ backers already.

\end{algorithmic}
\end{algorithm}


Based on the algorithm of ABS, we can now prove that the number of backers is positively correlated to the expected income of a dataset. A longer backing line represents better quality data, and it is a very visible indicator for a data consumer to find high quality datasets. Thus, we effectively outsourced the task of quantifying data quality to the ecosystem.

\begin{figure}[ht]
\centering
\includegraphics[width=10cm]{graphics/abs.png}
\caption{ABS system}
\label{fig:abs}
\end{figure}

\subsection{Business Flow for Data Renting}
\subfile{sections/ecosystem-workflow}


%\section{Business Cases} \label{sec:biz_case}
\subfile{sections/bizcase}

%\newpage
%\section{Limitations} \label{sec:limitation}
%While MPC has several advantages over other other techonologies to achieve 

%\newpage
%\section{Team} \label{sec:team}
%\subfile{sections/team}

\newpage
\section{Roadmap}  \label{sec:roadmap}
\subfile{sections/roadmap}

\newpage
\bibliography{sections/main}
\bibliographystyle{acm}
\end{document}